package com.ikaiwei.kaiweienginedemo;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.ikaiwei.scan.Func2;
import com.ikaiwei.scan.KaiWeiEngine;

import java.io.File;

public class MainActivity extends Activity {

    Handler hand = new Handler(Looper.getMainLooper());
    TextView text1;
    Button button1;

    int virCount = 0;

    /**
     * 开始病毒扫描
     */
    void startScan() {
        KaiWeiEngine eng = null;
        try {
            eng = new KaiWeiEngine(this);
            virCount = 0;
//            scanFile(new File("/sdcard/"), eng);
            scanFile(getFilesDir().getParentFile(), eng);
            setText("扫描结束,发现病毒:" + virCount);
        } catch (final Throwable e) {
            e.printStackTrace();
            setText("异常:" + e);
        } finally {
            if (eng != null)
                eng.close();
        }
    }

    /**
     * 递归扫描整个目录
     *
     * @param fi
     * @param eng
     * @throws Exception
     */
    void scanFile(File fi, KaiWeiEngine eng) throws Exception {
        if (fi.isDirectory()) {
            File[] files = fi.listFiles();
            if (files != null) {
                for (File f : files) {
                    scanFile(f, eng);
                }
            }
        } else {

            //减慢扫描速度,便于显示
            Thread.sleep(50);

            setText("正在扫描:" + fi.toString());
            boolean isVir = eng.scanOneFile(fi.toString());
            if (isVir) {
                virCount++;
                Log.d("virus", "病毒名称:" + eng.getVirusName());
            }
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        text1 = (TextView) findViewById(R.id.text1);
        button1 = (Button) findViewById(R.id.button1);

        KaiWeiEngine.update(this, new Func2<Exception, Integer>() {
            @Override
            public void run(Exception e, Integer integer) {
                if (e != null) {
                    setText("更新异常:" + e);
                } else {
                    setText("更新文件数:" + integer);
                }
            }
        });

        button1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {


                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        startScan();
                    }
                }).start();
            }
        });
    }


    void setText(final String text) {
        hand.post(new Runnable() {
            @Override
            public void run() {
                text1.setText(text);
            }
        });
    }


}
